# ChangeDisksAttach

## 1. API Description

This API (ChangeDisksAttach) is used to attach one or more disks to another instance. These disks are already attached to one instance.

{% hint style="info" %} <mark style="color:blue;">**Note**</mark>

* <mark style="color:blue;">Call this API to detach disks (</mark>[<mark style="color:purple;">`DetachDisks`</mark>](/api-reference/compute/vm/disk/detachdisks.md)<mark style="color:blue;">) first and then attach disks (</mark>[<mark style="color:purple;">`AttachDisks`</mark>](/api-reference/compute/vm/disk/attachdisks.md)<mark style="color:blue;">).</mark>
* <mark style="color:blue;">Status of disks must be</mark> <mark style="color:blue;">`IN_USE`</mark><mark style="color:blue;">, and disks are already attached to other instance.</mark>
* <mark style="color:blue;">Disks are currently attached to the same instance.</mark>
* <mark style="color:blue;">Quantity of disks cannot exceed available disk numbers of new instance.</mark>
* <mark style="color:blue;">This API is an async API. A request ID is returned after the creation request is sent. However, it does not mean the operation has been completed. You can use</mark> [<mark style="color:purple;">`DescribeDisks`</mark>](/api-reference/compute/vm/disk/describedisks.md) <mark style="color:blue;">to query the instance to which disks are attached. If the instance has changed to the new one, it means that the operation is successful.</mark>
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type            | Description                                           |
| -------------- | -------- | --------------- | ----------------------------------------------------- |
| diskIds        | Yes      | Array of String | ID list of disks.                                     |
| instanceId     | Yes      | String          | New ID of instance to which the disks to be attached. |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Attach disks to another instance.**

```json
POST /api/v2/vm HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: ChangeDisksAttach
<Common Request Params>

Request:
{
  "diskIds": [
    "your-disk-id"
  ],
  "instanceId": "your-instance-id"
}

Response:
{
  "requestId": "T425ED38F-1BE5-4274-B076-9A58C51F21A8",
  "response": {
    "requestId": "T425ED38F-1BE5-4274-B076-9A58C51F21A8"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code | Description |
| ---------------- | ---------- | ----------- |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.console.zenlayer.com/api-reference/compute/vm/disk/changedisksattach.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
